'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _Navigation = require('./Navigation');

var _Navigation2 = _interopRequireDefault(_Navigation);

var _context = require('../context');

var _context2 = _interopRequireDefault(_context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Navigation', function () {
  it('renders its children', function () {
    var Children = function Children() {
      return null;
    };
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
      _context2.default.Provider,
      { value: {} },
      _react2.default.createElement(
        _Navigation2.default,
        null,
        _react2.default.createElement(Children, null)
      )
    ));

    expect(wrapper.contains(_react2.default.createElement(Children, null))).toBe(true);
  });

  it('exposes navigation context as props', function () {
    var context = {
      activeStepIndex: 0,
      goToNextStep: jest.fn(),
      goToPrevStep: jest.fn(),
      goToStep: jest.fn(),
      totalSteps: 2
    };

    var navigationProps = void 0;

    (0, _enzyme.mount)(_react2.default.createElement(
      _context2.default.Provider,
      { value: context },
      _react2.default.createElement(_Navigation2.default, {
        render: function render(props) {
          navigationProps = props;
          return null;
        }
      })
    ));

    expect(navigationProps).toEqual(context);
  });
});