'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _context = require('../context');

var _context2 = _interopRequireDefault(_context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Progress = function Progress(_ref) {
  var children = _ref.children,
      render = _ref.render;
  return _react2.default.createElement(
    _context2.default.Consumer,
    null,
    function (_ref2) {
      var activeStepIndex = _ref2.activeStepIndex,
          totalSteps = _ref2.totalSteps;

      var percentage = (activeStepIndex + 1) * 100 / totalSteps;

      if (render) {
        return render({ percentage: percentage });
      }

      return typeof children === 'function' ? children(percentage) : children;
    }
  );
};

Progress.propTypes = {
  children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]),
  render: _propTypes2.default.func
};

exports.default = Progress;