'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _history = require('history');

var _context = require('../context');

var _context2 = _interopRequireDefault(_context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FIRST_STEP = 0;

var Wizard = function (_Component) {
  _inherits(Wizard, _Component);

  function Wizard(props) {
    _classCallCheck(this, Wizard);

    var _this = _possibleConstructorReturn(this, (Wizard.__proto__ || Object.getPrototypeOf(Wizard)).call(this, props));

    var steps = _this.steps;
    _this.state = {
      activeStepIndex: _this.props.defaultActiveStepIndex,
      steps: steps,
      totalSteps: steps.length
    };

    if (steps.length > 0) {
      var id = steps[_this.props.defaultActiveStepIndex].id;

      _this.replaceHistory(id);
    }

    _this.goToPrevStep = _this.goToPrevStep.bind(_this);
    _this.goToNextStep = _this.goToNextStep.bind(_this);
    _this.goToStep = _this.goToStep.bind(_this);
    return _this;
  }

  _createClass(Wizard, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      this.updateStepsIfNeeded(prevProps);
    }
  }, {
    key: 'updateStepsIfNeeded',
    value: function updateStepsIfNeeded(prevProps) {
      if (prevProps.children !== this.props.children) {
        var steps = this.steps;
        this.setState({ steps: steps, totalSteps: steps.length });
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var _props = this.props,
          baseUrl = _props.baseUrl,
          history = _props.history;
      var steps = this.state.steps;


      this.unlisten = history.listen(function (_ref, action) {
        var pathname = _ref.pathname;

        var noBrowserNavigationKeysPressed = action !== 'POP';
        if (noBrowserNavigationKeysPressed) return;

        var path = pathname.replace(baseUrl + '/', '');
        var stepIndex = steps.findIndex(function (step) {
          return step.id === path;
        });
        _this2.setActiveStepIndex(stepIndex);
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.unlisten();
    }
  }, {
    key: 'goToPrevStep',
    value: function goToPrevStep() {
      var activeStepIndex = this.activeStepIndex;
      this.goToStep(activeStepIndex - 1);
    }
  }, {
    key: 'goToNextStep',
    value: function goToNextStep() {
      var activeStepIndex = this.activeStepIndex;
      this.goToStep(activeStepIndex + 1);
    }
  }, {
    key: 'goToStep',
    value: function goToStep(index) {
      var _state = this.state,
          totalSteps = _state.totalSteps,
          steps = _state.steps;
      var onWizardFinished = this.props.onWizardFinished;

      var lastStep = index < FIRST_STEP || index > totalSteps - 1;

      if (lastStep) return onWizardFinished();
      this.setActiveStepIndex(index);

      var path = steps[index].id;
      this.pushHistory(path);
    }
  }, {
    key: 'pushHistory',
    value: function pushHistory(path) {
      var _props2 = this.props,
          baseUrl = _props2.baseUrl,
          history = _props2.history;

      history.push(baseUrl + '/' + path);
    }
  }, {
    key: 'replaceHistory',
    value: function replaceHistory(path) {
      var _props3 = this.props,
          baseUrl = _props3.baseUrl,
          history = _props3.history;

      history.replace(baseUrl + '/' + path);
    }
  }, {
    key: 'setActiveStepIndex',
    value: function setActiveStepIndex(index) {
      var onStepChanged = this.props.onStepChanged;
      var steps = this.state.steps;


      if (this.isUncontrolled) {
        this.setState({ activeStepIndex: index });
      }

      onStepChanged({
        activeStepIndex: index,
        step: steps[index]
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props4 = this.props,
          children = _props4.children,
          render = _props4.render;
      var totalSteps = this.state.totalSteps;

      var context = {
        activeStepIndex: this.activeStepIndex,
        goToNextStep: this.goToNextStep,
        goToPrevStep: this.goToPrevStep,
        goToStep: this.goToStep,
        totalSteps: totalSteps
      };

      return _react2.default.createElement(
        _context2.default.Provider,
        { value: context },
        render || children
      );
    }
  }, {
    key: 'steps',
    get: function get() {
      var children = this.props.children;

      var steps = [];

      _react.Children.forEach(children, function (child) {
        if (child && child.props.isSteps) {
          var grandchildren = child.props.children;


          _react.Children.forEach(grandchildren, function (child) {
            if (child && child.props.isStep) {
              var id = child.props.id;

              steps.push({ id: id });
            }
          });
        }
      });

      return steps;
    }
  }, {
    key: 'activeStepIndex',
    get: function get() {
      return this.isUncontrolled ? this.state.activeStepIndex : this.props.activeStepIndex;
    }
  }, {
    key: 'isUncontrolled',
    get: function get() {
      var activeStepIndex = this.props.activeStepIndex;

      return typeof activeStepIndex === 'undefined';
    }
  }]);

  return Wizard;
}(_react.Component);

Wizard.propTypes = {
  activeStepIndex: _propTypes2.default.number,
  baseUrl: _propTypes2.default.string,
  children: _propTypes2.default.node.isRequired,
  defaultActiveStepIndex: _propTypes2.default.number,
  history: _propTypes2.default.object,
  onStepChanged: _propTypes2.default.func,
  onWizardFinished: _propTypes2.default.func,
  render: _propTypes2.default.func
};

Wizard.defaultProps = {
  defaultActiveStepIndex: 0,
  history: (0, _history.createMemoryHistory)(),
  onStepChanged: function onStepChanged() {},
  onWizardFinished: function onWizardFinished() {}
};

exports.default = Wizard;